# Object File Reference

`#include <osg/Referenced>`
`#include <osg/CopyOp>`
`#include <osg/ref_ptr>`

Include dependency graph for Object:

This graph shows which files directly or indirectly include this file:

## Namespaces

namespace | osg

## Defines

#define | OSG_OBJECT 1
#define | META_Object(library, name)
| META_Object macro define the standard clone, isSameKindAs and className methods.

## Define Documentation

#define META_Object | ( | library,
|  | name |  | ) |

Value:

    virtual osg::Object* cloneType() const { return new name (); } \
            virtual osg::Object* clone(const osg::CopyOp& copyop) const { return new name (*this,copyop); } \
            virtual bool isSameKindAs(const osg::Object* obj) const { return dynamic_cast<const name *>(obj)!=NULL; } \
            virtual const char* libraryName() const { return #library; }\
            virtual const char* className() const { return #name; }

META_Object macro define the standard clone, isSameKindAs and className methods.

Use when subclassing from Object to make it more convenient to define the standard pure virtual clone, isSameKindAs and className methods which are required for all Object subclasses.

#define OSG_OBJECT 1